# sdkms/v1.ApprovalRequestsApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**approve**](ApprovalRequestsApi.md#approve) | **POST** /sys/v1/approval_requests/{request-id}/approve | Approve a request.
[**create_approval_request**](ApprovalRequestsApi.md#create_approval_request) | **POST** /sys/v1/approval_requests | Create approval request
[**delete_approval_request**](ApprovalRequestsApi.md#delete_approval_request) | **DELETE** /sys/v1/approval_requests/{request-id} | Delete an approval request.
[**deny**](ApprovalRequestsApi.md#deny) | **POST** /sys/v1/approval_requests/{request-id}/deny | Deny a request.
[**get_approval_request**](ApprovalRequestsApi.md#get_approval_request) | **GET** /sys/v1/approval_requests/{request-id} | Get an approval request.
[**get_approval_requests**](ApprovalRequestsApi.md#get_approval_requests) | **GET** /sys/v1/approval_requests | Get all approval requests
[**get_result**](ApprovalRequestsApi.md#get_result) | **POST** /sys/v1/approval_requests/{request-id}/result | Get the result for an approved or failed request.


# **approve**
> approve(request_id, body=body)

Approve a request.

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.ApprovalRequestsApi(sdkms/v1.ApiClient(configuration))
request_id = 'request_id_example' # str | Approval Request Identifier
body = sdkms/v1.ApproveRequest() # ApproveRequest | Approve an approval request (optional)

try: 
    # Approve a request.
    api_instance.approve(request_id, body=body)
except ApiException as e:
    print("Exception when calling ApprovalRequestsApi->approve: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **str**| Approval Request Identifier | 
 **body** | [**ApproveRequest**](ApproveRequest.md)| Approve an approval request | [optional] 

### Return type

void (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **create_approval_request**
> ApprovalRequest create_approval_request(body)

Create approval request

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.ApprovalRequestsApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.ApprovalRequestRequest() # ApprovalRequestRequest | Request to create an approval request.

try: 
    # Create approval request
    api_response = api_instance.create_approval_request(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ApprovalRequestsApi->create_approval_request: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApprovalRequestRequest**](ApprovalRequestRequest.md)| Request to create an approval request. | 

### Return type

[**ApprovalRequest**](ApprovalRequest.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_approval_request**
> delete_approval_request(request_id)

Delete an approval request.

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.ApprovalRequestsApi(sdkms/v1.ApiClient(configuration))
request_id = 'request_id_example' # str | Approval Request Identifier

try: 
    # Delete an approval request.
    api_instance.delete_approval_request(request_id)
except ApiException as e:
    print("Exception when calling ApprovalRequestsApi->delete_approval_request: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **str**| Approval Request Identifier | 

### Return type

void (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deny**
> deny(request_id)

Deny a request.

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.ApprovalRequestsApi(sdkms/v1.ApiClient(configuration))
request_id = 'request_id_example' # str | Approval Request Identifier

try: 
    # Deny a request.
    api_instance.deny(request_id)
except ApiException as e:
    print("Exception when calling ApprovalRequestsApi->deny: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **str**| Approval Request Identifier | 

### Return type

void (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_approval_request**
> ApprovalRequest get_approval_request(request_id)

Get an approval request.

Get the details and status of a particular approval request.

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.ApprovalRequestsApi(sdkms/v1.ApiClient(configuration))
request_id = 'request_id_example' # str | Approval Request Identifier

try: 
    # Get an approval request.
    api_response = api_instance.get_approval_request(request_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ApprovalRequestsApi->get_approval_request: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **str**| Approval Request Identifier | 

### Return type

[**ApprovalRequest**](ApprovalRequest.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_approval_requests**
> list[ApprovalRequest] get_approval_requests(requester=requester, reviewer=reviewer, subject=subject, status=status)

Get all approval requests

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.ApprovalRequestsApi(sdkms/v1.ApiClient(configuration))
requester = 'requester_example' # str | Only retrieve approval requests with the specified requester ID (optional)
reviewer = 'reviewer_example' # str | Only retrieve approval requests with the specified reviewer ID (optional)
subject = 'subject_example' # str | Only retrieve approval requests with the specified subject ID (optional)
status = 'status_example' # str | Only retrieve approval requests with the specified approval status (optional)

try: 
    # Get all approval requests
    api_response = api_instance.get_approval_requests(requester=requester, reviewer=reviewer, subject=subject, status=status)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ApprovalRequestsApi->get_approval_requests: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **requester** | **str**| Only retrieve approval requests with the specified requester ID | [optional] 
 **reviewer** | **str**| Only retrieve approval requests with the specified reviewer ID | [optional] 
 **subject** | **str**| Only retrieve approval requests with the specified subject ID | [optional] 
 **status** | **str**| Only retrieve approval requests with the specified approval status | [optional] 

### Return type

[**list[ApprovalRequest]**](ApprovalRequest.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_result**
> ApprovableResult get_result(request_id)

Get the result for an approved or failed request.

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.ApprovalRequestsApi(sdkms/v1.ApiClient(configuration))
request_id = 'request_id_example' # str | Approval Request Identifier

try: 
    # Get the result for an approved or failed request.
    api_response = api_instance.get_result(request_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ApprovalRequestsApi->get_result: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **request_id** | **str**| Approval Request Identifier | 

### Return type

[**ApprovableResult**](ApprovableResult.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

